#!/usr/bin/env python
# Copyright (c) 2011 Jilles Tjoelker
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# This script writes a shell script to stdout, to be run using the shell
# under test. Any output from the shell script indicates a test failure.

tests0f = ['']
tests0t = []
tests1f = ['""']
tests1t = ['-n', '-z', '-f', '=', '!=', '-eq', '-ef', '!', '-a', '-o', '\(',
        '\)', 'x']
tests2f = ['-f /', '-d /etc/passwd', '-e /var/empty/nosuchfile']
tests2t = ['-f /etc/passwd', '-d /']
tests3f = ['-1 -eq -2']
tests3t = ['-1 -eq -1', '-2 -lt -1']
tests4f = []
tests4t = []

tests2t += ['-n ' + t for t in tests1t]
tests2f += ['-n ' + t for t in tests1f]
tests2f += ['-z ' + t for t in tests1t]
tests2t += ['-z ' + t for t in tests1f]
tests2f += ['! ' + t for t in tests1t]
tests2t += ['! ' + t for t in tests1f]

tests3f += ['! ' + t for t in tests2t]
tests3t += ['! ' + t for t in tests2f]

tests3t += [t1 + (' = ' if t1 == t2 else ' != ') + t2
        for t1 in tests1f + tests1t for t2 in tests1f + tests1t]
tests3f += [t1 + (' != ' if t1 == t2 else ' = ') + t2
        for t1 in tests1f + tests1t for t2 in tests1f + tests1t]

tests4f += ['! ' + t for t in tests3t]
tests4t += ['! ' + t for t in tests3f]

numtests = len(tests0f + tests0t + tests1f + tests1t +
        tests2f + tests2t + tests3f + tests3t + tests4f + tests4t)
print "# %d tests" % numtests
print """
t() {
        expect=$1
        shift
        eval "test $*"
        actual=$?
        if [ "$expect" != "$actual" ]; then
                printf "Bad: %s\\n" "$*"
        fi
}
"""
for t in tests0f + tests1f + tests2f + tests3f + tests4f:
        print "t 1 '%s'" % t
for t in tests0t + tests1t + tests2t + tests3t + tests4t:
        print "t 0 '%s'" % t
